.TH XDTREE 1L
.SH NAME
xdtree \- display directory tree structures
.SH SYNOPSIS
.B xdtree
[
.I \-aDfghHNpsStvx
] [
.I \-l level
] [
.I \-c linelength
] [
.BR directory ...
]
.SH DESCRIPTION
.I xdtree
is an extension of
.I dtree
and displays a graphic representation of the directory structure of each given
.B directory 
and its children either on the terminal stdout or on an X11 window, using
the Motif widgets (default). If no directories are specified, the current
directory is used.
By default, only directories, not regular files, are shown, and only their
filenames are given.  Various options add additional
information to the tree.
.SS OPTIONS
.TP
.I \-a
Include files in the listing (excluding entries beginning with '.').
.TP
.I \-c linelength
Make
.I linelength
the length of each
column of the printout.  By default, this is 14.
Any entries longer than
the column length are truncated accordingly, and the last character that
fits into the column is replaced by an asterisk.
This option only has an effect if the
.I -v 
option is specified.
.TP
.I \-l level
Search only up to the specified level. (Maximum is 10).
.TP
.I \-D
List directories first.  For each directory, its subdirectories
will be listed first, and then all of its other entries.
.TP
.I \-f
List files first.  The reverse of
.IR  \-D .
.TP
.I \-S
Long listing.  Display useful information to the right of
each entry: the name of the file's owner, its size in blocks, and its mode.
.TP
.I \-g
Same as the
.I \-S
option, except that the group name is used instead of
the owner name.  If both the
.I \-S
and
.I \-g
options are used, both the
owner and group will be displayed.
.TP
.I \-H
Display a header at the top of the printout that gives the time and
date that the printout was made and a summary of the type of
information contained in the tree.
.TP
.I \-N
No sort.  Entries are listed in the order they are read
from the directories.
.TP
.I \-p
Include entries beginning with '.' (except '.' and '..').
.TP
.I \-s
Simplify the long listing: display the user id, size in blocks, and
octal mode of the file.  This option implies the
.I \-S
option unless the
.I \-g
option is specified.
.TP
.I \-v
Do not let column lengths vary; use the same
width for each column of output.  The width defaults to 14
but can be set with the
.I \-c
option.
.TP
.I \-x
Do not cross file systems.  
.I xdtree
will not cross over to a
subdirectory if it is on a different file system.
.TP
.I \-h
Will print a list of the options.
.TP
.I \-t
Terminal mode.
In default mode
.I
xdtree
will display the directory tree structure in an X11 window.
The \-t option allows the tree to be printed on the terminal stdout.

Under the X11 window mode, a button click on a tree node,  makes it
the "active" node. The name of the "active" node always appears
at the top of the window, under the "quit" button.
Below the area where the name of the "active" node is shown,
a table displays the mode of the node, the group and user IDs, and its
size.
Next to this menu are
the \fIfile,\fR \fIdirectory,\fR and \fIPrint-Tree\fR option buttons.
There are
five \fIfile\fR options: \fIview, topview, edit\fR, \fIprint\fR, and
\fIremove\fR.
There are three \fIdirectory\fR options: \fIshow subtree, list files\fR,
and \fIlist '../'\fR.
Thus, the \-c, \-S, \-g, \-s, and \-v options are meaningful only
when the \-t option is used.
However, the \-S, \-g, and \-H options are accessible from the toggle buttons
in the \fIPrint-Tree\fR options menu.
.TP
.B view 
Display the whole file on a scrolled window.
Since the program reads a file all at once,
the wait may be significant for a very large file.  However, the option
.TP
.B topview 
shows only the top of the file (2000 bytes).
.TP
.B edit
Edit the file. \fIxdtree\fR first checks and executes the command 
specified by the
.B xdtree*editor:
resource in .Xdefaults. If that command is NULL, \fIxdtree\fR
forks an hpterm window using the editor command specified
in the
.B EDITOR
environmental variable. If that variable is not specified, it uses \fIvi.\fR
.TP
.B print
Print the file. It prints the file on the printer destination specified
by the
.B xdtree*lpdest:
resource in .Xdefaults.
If that variable is not specified it uses
the default lp destination.
The same variable is also being used when the \fIPrint-Tree\fR button
is selected.
.TP
.B remove
Remove that file. The file icon is disabled and the file is removed.
.TP
.B "show subtree"
Show the directory subtree starting from the selected "active"
directory node.
.TP
.B "list files"
List all files and directories for the "active" directory node.
This is equivalent to an "ls" command on that directory.
.TP
.B "list \.\.\/"
List the directories in the parent (top) directory.  Allows the user
to traverse upwards the directory tree.
.TP
.B "Print-Tree"
Print the tree.  This is equivalent to using the \fIxdtree\fR command
with the \-t option and piping the output to your printer.

Except for the \fIview\fR and \fItopview\fR options, in all other cases
a click on the "quit" button of the "parent" will
cause the "parent" \fIxdtree\fR window to freeze until the selected command
has been executed or the "child" window has been killed.
Then the "parent" window will automatically die.
Thus it is recommended to kill "children" applications before
you try to kill the "parent".

On a color terminal, one can choose different colors to distinguish
between directories, files, and symbolic links.
To set up a simple color scheme for \fIxdtree\fR, put the following entries
in your ~/.Xdefaults file:

xdtree*geometry:                     500x500
.br
xdtree*quit.background:              DarkSlateBlue
.br
xdtree*dir.background:               Red      
.br
xdtree*sym_link.background:          Brown  
.br
xdtree*options.background:           Red		

A set of simple resources is also specified in
/usr/lib/X11/app-defaults/XDtree
.SH AUTHOR
Dave Borman, Digital Unix Engineering Group, wrote the original
dtree program.
.br
decvax!borman
.br
Originally written at St. Olaf College, Northfield, MN.
.br
Additions for the X11 windows display by K. Konstantinides,
Hewlett-Packard Laboratories.
Copyright: Hewlett-Packard, 1990, and 1992.
e-mail:kk@hpkronos.hpl.hp.com
